/*******************************************************************
 * WiFi Module UDP Test Program
 * Weather Board$B$r;HMQ(B
 * UDP$B%3%^%s%I$G2<5-<B9T(B
 * $B!!30It=PNO$N%*%s%*%U!"30It>uBV$NF~NO!"7WB,%G!<%?$NF~NO(B
 *******************************************************************/
#include <p24fxxxx.h>

/* $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B */
_CONFIG1(WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GCP_OFF & JTAGEN_OFF)
_CONFIG2(POSCMOD_NONE & I2C1SEL_PRI & OSCIOFNC_ON & FCKSM_CSDCMD
        & FNOSC_FRCPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
_CONFIG3(SOSCSEL_IO)

/** I2C$BMQ%T%s@_Dj!J29<>EY%;%s%5MQ!K(B *********/
#define SCK     LATAbits.LATA4
#define SDA     PORTBbits.RB4
#define TRIS_SDA    TRISBbits.TRISB4
/** SPI$BMQ%T%s@_Dj!J5$05%;%s%5MQ!K(B ***********/
#define SPICS       LATBbits.LATB7
#define SPISCK      LATBbits.LATB13
#define SPISI       PORTBbits.RB8
#define SPISO       LATBbits.LATB9

/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
#define     Fosc     32
unsigned char State, MState;
unsigned char RcvBuf[10][16];
unsigned char SndBuf[32];
unsigned char Temp[3], Humi[3];
int Index, i, cursave, curget;
unsigned long Pascal, Ilumi;

/* $B4X?t%W%m%H%?%$%T%s%0(B */
unsigned char getcUSART (void);
void Send(unsigned char Data);
void SendStr(unsigned char * str);
void SendCmd(unsigned char *cmd);
void RcvDisp(void);
void TestExec(void);
void delay_us(unsigned short usec);
void delay_ms(unsigned short msec);
void SPIOut(unsigned char data);
unsigned char SPIRcv(void);
unsigned int SPIRcv16(void);
void Cmnd(unsigned char data);
void TRStart(void);
unsigned char SendData(unsigned char data);
unsigned char ReadData(void);
int  GetADC(int ch);
void SPICmd(unsigned char reg, unsigned char cmd);
unsigned char SPI8bit(unsigned char reg);
unsigned int SPI16bit(unsigned char reg);

/* WiFi USB$B@_DjMQ%3%^%s%I%G!<%?(B */
unsigned char msg1[] = "$$$";                               // $B%3%^%s%I%b!<%I;XDj(B
unsigned char msg2[] = "factory R\r\n";                     // $B=i4|2=(B
unsigned char msg3[] = "set wlan ssid 000A79E7FA41\r\n";    // AP$B$N(BSSID$B;XDj(B
unsigned char msg4[] = "set wlan pass 73733829\r\n";        // AP$BMQ%M%C%H%o!<%/%-!<;XDj(B
unsigned char msg5[] = "set ip proto 1\r\n";                // UDP$B;XDj(B
unsigned char msg6[] = "set ip host 192.168.1.27\r\n";      // $B%/%i%$%"%s%HB&%"%I%l%9;XDj(B
unsigned char msg7[] = "set ip remote 3000\r\n";            // $B%/%i%$%"%s%HB&%]!<%H;XDj(B
unsigned char msg8[] = "set ip local 2000\r\n";             // $B<+J,$N%]!<%H;XDj(B
unsigned char msg9[] = "set b i 0\r\n";                     // $B%V%m!<%I%-%c%9%HDd;_(B
unsigned char msg10[] = "set comm remote 0\r\n";            // Hello$B%a%C%;!<%86X;_(B
unsigned char msg11[] = "set comm open 0\r\n";              // Open$B%a%C%;!<%86X;_(B
unsigned char msg12[] = "save\r\n";                         // $B@_DjJ]B8(B
unsigned char msg13[] = "reboot\r\n";                       // $B:F5/F0(B
unsigned char msg14[] = "close\r\n";                        // TCP$B%/%m!<%:%3%^%s%I(B

/*********** $B%a%$%s4X?t(B **************************/
int main(void)
{
    CLKDIV = 0x0020;                            // 96MHz PLL Off CPU 32MHz
    /* WiFi$B3+;O%a%C%;!<%8%9%-%C%W(B */
    delay_ms(1000);                             // $BL5>r7o%9%-%C%W(B
    /* I/O$B=i4|2=(B */
    LATB  = 0x0C00;                             // LED Off, TX High
    TRISA = 0x000F;                             // $B%]!<%H(BA
    TRISB = 0x5D57;                             // $B%]!<%H(BB
    /* UART1$B%T%s3dIU(B */
    RPINR18bits.U1RXR = 11;         // UART1 RX to RP11
    RPOR5bits.RP10R = 3;            // UART1 TX to RP10
    /* UART1$B=i4|@_Dj!!(B115kbps or 9.6kbps  */
    U1MODE = 0x8808;                            // UART1$B=i4|@_Dj(B BRGH=1
    U1STA =  0x0400;                            // UART1$B=i4|@_Dj(B
//    U1BRG = 34;                                 // 115kbps@32MHz
    U1BRG = 416;                                // 9.6kbps
    IPC2bits.U1RXIP = 4;                        // UART1$B3d$j9~$_%l%Y%k(B
    IEC0bits.U1RXIE = 1;                        // UART1$B<u?.3d$j9~$_5v2D(B
    U1MODEbits.UARTEN = 1;
    /* A/D$B%3%s%P!<%?=i4|2=(B */
    AD1CON1 = 0x80E0;               // manual sample start, auto-convert
    AD1CON2 = 0;                // AVdd, AVss, MUXA only
    AD1CON3 = 0x1F05;               // 31 Tad auto-sample, Tad = 5*Tcy
    AD1CHS  = 0x0000;               // Channel select Lower 4bits
    AD1PCFG = 0xFFE0;               // RA0,1,RB0,1 only analog
    AD1CSSL = 0;                // No scanned inputs
    /*** $B5<;w(BI2C$B!"(BSPI$B%T%s=i4|2=(B **/
    TRIS_SDA = 0;                               // SDA$B=PNO%b!<%I(B
    SCK = 0;                                    // SCL Low
    SPISCK = 0;                 // SCL Low
    SPISO = 0;                  // SDA High
    /* $B%?%$%^#1%9%?!<%H(B */
    PR1 = 0x5573;               // 0.35sec$B<~4|(B
    T1CON = 0x8030;             // $B%W%j%9%1!<%i(B1/256
    IFS0bits.T1IF = 0;                          // $B3d$j9~$_%U%i%0%/%j%"(B
    IEC0bits.T1IE = 1;              // $B3d$j9~$_5v2D(B
    /* $BJQ?t=i4|2=(B */
    Index = 0;                                  // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
    State = 0;                                  // $B%9%F!<%HJQ?t%j%;%C%H(B
    cursave = 0;                                // $B=[4D%P%C%U%!%]%$%s%?%j%;%C%H(B
    curget = 0;
    MState = 0;
    Cmnd(0x1E);                 // $B29<>EY%;%s%5%j%;%C%H%3%^%s%I(B

    /*************** $B%a%$%s%k!<%W(B ********************/
    while(1){
        switch(State){
            case 0:
                if(PORTBbits.RB14 == 0)             // SW$B$,2!$5$l$F$$$k>l9g(B
                {
                    /** WiFi$B%b%8%e!<%k=i4|2=!!%$%s%U%i%b!<%I(B */
                    SendCmd(msg1);                  //$$$
                    delay_ms(1000);
                    SendCmd(msg2);
                    SendCmd(msg3);
                    SendCmd(msg4);
                    SendCmd(msg5);
                    SendCmd(msg6);                 // $B3+;O%a%C%;!<%8%9%-%C%W(B
                    SendCmd(msg7);
                    SendCmd(msg8);
                    SendCmd(msg9);
                    SendCmd(msg10);
                    SendCmd(msg11);
                    SendCmd(msg12);
                    SendCmd(msg13);
                    /** USART $B:F@_Dj(B*/
                    U1MODE = 0x8808;                // UART1$B=i4|@_Dj(B BRGH=1
                    U1STA =  0x0400;                // UART1$B=i4|@_Dj(B
                //    U1BRG = 34;                   // 115kbps@32MHz
                    U1BRG = 416;                    // 9.6kbps
                }
                State = 1;                          //$B<!$X(B
                break;
            case 1:
                delay_ms(2000);
                Index = 0;
                SendStr(SndBuf);
                State = 2;                          // $B<!$X(B
                break;
            case 2:
                Index = 0;                          // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
                delay_ms(1000);                     // $B@\B3BT$ACY1d(B
                State = 3;
                break;
            case 3:
                /* $B<u?.%3%^%s%I=hM}(B */
                if((curget != cursave)&&(RcvBuf[curget][0] == 'S')){
                    SndBuf[0] = 'M';                // $BJV?.%^!<%/J]B8(B
                    SndBuf[1] = RcvBuf[curget][1];  // $BJV?.6hJLJ]B8(B
                    TestExec();                     // $B%3%^%s%I=hM}<B9T(B
                    Index = 0;                      // $B%P%C%U%!%]%$%s%?=i4|2=(B
                    curget++;                       // $B=[4D%P%C%U%!99?7(B
                    if(curget == 10)                // $B=[4D%P%C%U%!$N:G8e$r1[$($?>l9g(B
                        curget = 0;                 // $B=[4D%P%C%U%!$N:G=i$KLa$9(B
                 }
                break;
            default:
                break;
        }
    }
}

/****************************************
 *$B!!<u?.%G!<%?=hM}4X?t(B
 ****************************************/
void TestExec(void)
{
    int data;

    /* $B%G!<%?=hM}(B  */
    switch(RcvBuf[curget][1]){                          // $B<u?.%G!<%?$GJ,4t(B
        /* $B>uBVF~NO$N>l9g(B */
        case 'B':
            if(PORTBbits.RB5)                           // $B30ItF~NO(B1
                SndBuf[2] = '0';
            else
                SndBuf[2] = '1';
            if(PORTAbits.RA3 == 0)                      // $B30ItF~NO(B2
                SndBuf[3] = '0';
            else
                SndBuf[3] = '1';
            if(PORTAbits.RA2 == 0)                      // $B30ItF~NO(B3
                SndBuf[4] = '0';
            else
                SndBuf[4] = '1';
            if(PORTBbits.RB3)                           // $B30ItF~NO(B4
                SndBuf[5] = '0';
            else
                SndBuf[5] = '1';
             SendStr(SndBuf);                            // $BAw?.<B9T(B
            break;
        /* $B=PNO@)8f$N>l9g(B */
        case 'C':
            SndBuf[2] = RcvBuf[curget][2];              // $BJV?.6hJLJ]B8(B
            switch(RcvBuf[curget][2]){                  // $B6hJL5-9f$GJ,4t(B
                case '1':                               // $B=PNO#1(B
                    if(RcvBuf[curget][3] == '1'){       // On$B@)8f$N>l9g(B
                        LATBbits.LATB5 = 1;
                        SndBuf[3] = '1';
                    }
                    else{                               // Off$B@)8f$N>l9g(B
                        LATBbits.LATB5 = 0;
                        SndBuf[3] = '0';
                    }
                    break;
                case '2':                               // $B=PNO(B2
                    if(RcvBuf[curget][3] == '1'){       // On$B@)8f$N>l9g(B
                        LATBbits.LATB3 = 1;
                        SndBuf[3] = '1';
                    }
                    else{                               // Off$B@)8f$N>l9g(B
                        LATBbits.LATB3 = 0;
                        SndBuf[3] = '0';
                    }
                    break;
                default: break;
            }
            SendStr(SndBuf);                            // $BAw?.<B9T(B
            LATBbits.LATB15 ^= 1;                       // $BL\0u(BLED
            break;
        /* $B7WB,$N>l9g(B */
        case 'A':
            SndBuf[2] = RcvBuf[curget][2];              // $BJV?.6hJLJ]B8(B
            for(i=0; i<3; i++){                         // $B29EY3JG<(B
                SndBuf[i+3] = Temp[i];
            }
            for(i=0; i<3; i++){                         // $B<>EY3JG<(B
                SndBuf[i+6] = Humi[i];
            }
            SndBuf[9] = (unsigned char)(Pascal / 256ul);// $B5$053JG<(B
            SndBuf[10] = (unsigned char)(Pascal & 0xFF);
            SndBuf[11] = (unsigned char)(Ilumi >> 8);   // $B>HEY3JG<(B
            SndBuf[12] = (unsigned char)(Ilumi & 0xFF);
            /* $BHFMQ7WB,DI2C(B */
            for(i= 0; i<4; i++){
                data = GetADC(i);                       // CH0 to CH3
                SndBuf[13+2*i] = (unsigned char)(data >> 8);
                SndBuf[14+2*i] = (unsigned char)(data & 0xFF);
            }
            SendStr(SndBuf);                            // $BAw?.<B9T(B
            break;
        /* $B=*N;%3%^%s%I$N>l9g(B */
        case 'N':
            SendStr(msg1);                              // $$$$B$G%3%^%s%I%b!<%I$X(B
            delay_ms(1000);                             // $BJV?.%9%-%C%W(B
            SendCmd(msg14);                             // Close$BAw?.(B
            SendCmd(msg13);                             // Reboot$BAw?.(B
            break;
        default: break;
    }
}
/**************************************
 * $B%?%$%^#13d$j9~$_=hM}4X?t(B
 * 350msec$B<~4|$G7WB,<B9T(B
 ***************************************/
void __attribute__((interrupt, no_auto_psv)) _T1Interrupt(void){
    unsigned char MSB8, Lower;

    IFS0bits.T1IF = 0;                          // $B3d$j9~$_%U%i%0%/%j%"(B
    switch(MState){
        case 0:
            Cmnd(0x03);                         // $B29EY7WB,%9%?!<%H(B
            Ilumi = GetADC(4);                  // $B>HEY%G!<%?<hF@(B
            MState = 1;                         // $B<!$X(B
            break;
        case 1:
            LATBbits.LATB15 ^= 1;               // $BL\0u(BLED
            for(i=0; i<3; i++)                  // $B29EY%G!<%?<hF@(B
                Temp[i] = ReadData();
            Cmnd(0x05);                         // $B<>EY7WB,%9%?!<%H(B
            SPICmd(0x03, 0x0C);                 // $B<!$N5$057WB,%H%j%,%*%s(B
            Ilumi = GetADC(4);                  // $B>HEY%G!<%?<hF@(B
            MState = 2;                         // $B<!$X(B
            break;
        case 2:
            for(i=0; i<3; i++)                  // $B<>EY%G!<%?<hF@(B
                Humi[i] = ReadData();
            Ilumi = GetADC(4);                  // $B>HEY%G!<%?<hF@(B
            MState = 3;                         // $B<!$X(B
            break;
        case 3:
            if(SPI8bit(0x07) & 0x20){       // $B5$057WB,%l%G%#%A%'%C%/(B
                MSB8 = SPI8bit(0x1F);       // $B>e0L(B8$B%S%C%HF~NO(B
                Lower = SPI16bit(0x20);     // $B2<0L(B16$B%S%C%HF~NO(B
                Pascal = (unsigned long)MSB8 * 65536+(unsigned long)Lower;
                Pascal = Pascal / 40;       // $B%X%/%H%Q%9%+%k$KJQ49(B
            }
            Ilumi = GetADC(4);                  // $B>HEY%G!<%?<hF@(B
            Cmnd(0x03);                         // $B<!$N29EY7WB,%9%?!<%H(B
            MState = 1;                         // $B29EY%G!<%?<hF@$KLa$C$F7+$jJV$7(B
            break;
        default:
            break;
    }
}

/***************************************
*  UART$B<u?.3d$j9~$_=hM}4X?t(B
****************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void)
{
    char  data;

    /* $B<u?.%(%i!<%A%'%C%/(B */
    IFS0bits.U1RXIF = 0;                            // $B3d$j9~$_%U%i%0%/%j%"(B
    if(U1STAbits.OERR || U1STAbits.FERR) {
        data = U1RXREG;;
        U1STA &= 0xFFF0;                            // $B%(%i!<%U%i%0%/%j%"(B
        U1MODE = 0;                                 // UART1$BDd;_(B
        U1MODE = 0x8808;                            // UART1$BM-8z2=(B
    }
    else {                                          // $B@5>o<u?.$N>l9g(B
        if((State > 2)&&(Index<16)){                //
            RcvBuf[cursave][Index++] = U1RXREG;     // $B%G!<%?<h$j=P$7(B
            if(RcvBuf[cursave][Index-1] == 'E'){    // $B=*N;%^!<%/(BE$B8!=P(B
                cursave++;                          // $B=[4D%P%C%U%!<!$X(B
                if(cursave == 10)                   // $B=[4D%P%C%U%!$N:G8e$r1[$($?>l9g(B
                    cursave = 0;                    // $B=[4D%P%C%U%!$N:G=i$KLa$9(B
            }
        }
        else                                        // $B%3%^%s%I<B9TCf$GL5$$>l9g(B
            data = U1RXREG;                         // $BFI$_Ht$P$7$FL5;k(B
    }
}
 /********************************
 * UART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!U1STAbits.TRMT);              // $BAw?.%l%G%#!<BT$A(B
    U1TXREG = Data;                      // $BAw?.<B9T(B
}
/********************************
 * WiFi$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendStr(unsigned char * str)
{
    for(i= 0; i<32; i++)                // 32$B%P%$%HAw?.(B
        Send(*str++);                   // $BAw?.<B9T(B
}
/********************************
 * WiFi$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(unsigned char *cmd)
{
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                   // $BAw?.<B9T(B
    delay_ms(1000);                     // $BJV?.%9%-%C%WMQCY1d(B
}
/*********************************************************
*  $B29<>EY%;%s%5@)8f4X?t!J(BI2C$B$b$I$-(B)
*  $B%W%m%0%i%`(BI2C$B$G<B8=(B
*********************************************************/
/****** $B%W%m%0%i%`(BI2C Transmission Start $B=PNO(B ********/
void TRStart(void){
    TRIS_SDA = 0;               // SDA$B=PNO%b!<%I(B
    SDA = 1; Nop(); Nop();          // SDA High
    SCK = 1; Nop(); Nop();          // SCK HIGH
    SDA = 0; Nop(); Nop();          // SDA Low
    SCK = 0; Nop(); Nop();Nop(); Nop();         // SCK Low
    SCK = 1; Nop(); Nop();          // SCK High
    SDA = 1; Nop(); Nop();          // SDA High
    SCK = 0;                    // SCK Low
}
/***** $B%W%m%0%i%`(BI2C 1$B%P%$%H%3%^%s%I=PNO(B ***************/
void Cmnd(unsigned char data){
    TRStart();              // Trasnsmit Start
    SendData(data);             // 1$B%P%$%HAw?.!!(BACK$B3NG'(B
}

/******* $B%W%m%0%i%`(BI2C  1$B%P%$%HF~NO%m!<%l%Y%k4X?t(B *********/
unsigned char ReadData(void){
    unsigned char mask, pos, data;

    TRIS_SDA = 1;               // SDA$BF~NO%b!<%I(B
    data = 0;                   // $B<u?.%P%C%U%!%/%j%"(B
    mask = 0x80;                // $B<u?.%S%C%H0LCV%;%C%H(B
    for(pos=0; pos<8; pos++){           // 8$B%S%C%HJ,7+$jJV$7(B
        SCK = 1; Nop(); Nop();          // SCK High
        if(SDA == 1)                // SDA$BF~NO(B
            data = data | mask;         // $B%G!<%?%S%C%H%;%C%H(B
        mask = mask >> 1;           // $B<!$N%S%C%H$X(B
        SCK = 0;                // SCK Low
    }
    /* Send ACK */
    SDA = 0;                    // ACK$B%;%C%H(B
    TRIS_SDA = 0;               // SDA$B=PNO%b!<%I(B
    SCK = 1; Nop(); Nop(); Nop();Nop();         // SCK High
    SCK = 0; Nop();             // SCK Low
    return(data);               // $B<u?.%G!<%?$rJV$9(B
}
/******** $B%W%m%0%i%`(BI2C 1$B%P%$%H=PNO%m!<%l%Y%k4X?t(B **********/
unsigned char SendData(unsigned char data){
    unsigned char mask, pos, flag;

    mask = 0x80;                // $B%S%C%H0LCV%;%C%H(B
    for(pos=0; pos<8; pos++){           // 8$B%S%C%H7+$jJV$7(B
        SCK = 0;                // SCK Low
        SDA = (mask & data) ? 1:0;      // $B%S%C%H%;%C%H(B
        Nop();
        SCK = 1;                // SCK High
        mask = mask >> 1;           // $B<!$N%S%C%H$X(B
        Nop();
    }
    /** ACK Receive **/
    TRIS_SDA = 1;               // SDA$BF~NO%b!<%I(B
    SCK = 0; Nop(); Nop();          // SCK Low
    SCK = 1; Nop();             // SCK High
    if(SDA == 0)                // ACK$B3NG'(B
        flag = 0;               // $B@5>o(BACK
    else
        flag = 0xFF;                // ACK$B0[>o(B
    SCK = 0; Nop();             // SCK Low
    SDA = 1;                    // SCK High
    return(flag);               // ACK$B7k2L$rJV$9(B
}
/**************************************************
*  $B%"%J%m%0%G!<%?F~NO4X?t(B
*  AD$B%3%s%P!<%?$NF~NO@)8f(B
***************************************************/
int GetADC(int ch){
    // Channel 0 Conversion
    AD1CON1bits.ADON = 0;           // $B$$$C$?$s(BAD$B%*%U(B
    AD1CHS = ch;                                // $B%A%c%M%kA*Br(B
    AD1CON1bits.ADON = 1;                       // A/D$BM-8z2=(B
    AD1CON1bits.SAMP = 1;                       // $BJQ493+;O(B
    while(!AD1CON1bits.DONE);                   // $BJQ49=*N;BT$A(B
    return(ADC1BUF0);                           // $BJQ497k2L<hF@(B
}
/*********************************************************
* $B5$05%;%s%5(B  $B%W%m%0%i%`(BSPI$B%i%$%V%i%j(B
* $B!!@)8f%3%^%s%I=PNO!"(B1$B%P%$%H%G!<%?F~NO!"(B2$B%P%$%H%G!<%?F~NO(B
**********************************************************/
/****** $B@)8f%3%^%s%I!\%3%^%s%I%G!<%?=q$-9~$_(B ******/
void SPICmd(unsigned char reg, unsigned char cmd){
    SPICS = 0;
    SPIOut((reg << 2) | 0x02);          // Write$B%b!<%I%3%^%s%I(B
    SPIOut(cmd);                // $B%G!<%?=PNO(B
    SPICS = 1;
}
/****** $B@)8f%3%^%s%I=PNO!\(B8$B%S%C%H%G!<%?F~NO(B *******/
unsigned char SPI8bit(unsigned char reg){
    unsigned char data;

    SPICS = 0;
    SPIOut(reg << 2);               // Read$B%b!<%I%3%^%s%I(B
    data = SPIRcv();                // 1$B%P%$%HF~NO(B
    SPICS = 1;
    return(data);               // $B%P%$%H%G!<%?$rJV$9(B
}
/****** $B@)8f%3%^%s%I!\(B16$B%S%C%H%G!<%?F~NO(B **********/
unsigned int SPI16bit(unsigned char reg){
    unsigned int data;

    SPICS = 0;
    SPIOut(reg << 2);           // Read$B%b!<%I%3%^%s%I(B
    data = SPIRcv16();          // 16$B%S%C%HF~NO(B
    SPICS = 1;
    return(data);               // 16$B%S%C%H$H$7$FJV$9(B
}
/***** $B%W%m%0%i%`(BSPI$B$G(B1$B%P%$%H=PNO(B  CS$B$O(BLow *******/
void SPIOut(unsigned char data){
    int i;
    unsigned char BitPos;

    /* Data Out */
    BitPos = 0x80;              // $B%S%C%H0LCV=i4|CM(B
    for(i=0; i<8; i++){             // 8$B%S%C%H7+$jJV$7(B
        SPISO = (data & BitPos) ? 1:0;          // $B%S%C%H=PNO(B
        BitPos = BitPos >> 1;           // $B%S%C%H0LCV0\F0(B
        SPISCK = 1;
        SPISCK = 1;             // SCK$B%Q%k%9I}3NJ](B
        SPISCK = 0;
    }
}
/***** $B%W%m%0%i%`(BSPI$B$G(B1$B%P%$%HF~NO(B  CS$B$O(BLow ********/
unsigned char SPIRcv(void){
    int i;
    unsigned char BitPos, data;

    data = 0;
    BitPos =0x80;               // $B%S%C%H0LCV%j%;%C%H(B
    for(i=0; i<8; i++){             // 8$B%S%C%H7+$jJV$7(B
        SPISCK = 1;
        if(SPISI)               // $B%S%C%HF~NO(B
            data |= BitPos;
        BitPos = BitPos >> 1;           // $B%S%C%H%7%U%H(B
        SPISCK = 0;
    }
    return(data);               // $B<u?.%G!<%?$rLa$9(B
}
/***** $B%W%m%0%i%`(BSPI$B$GO"B3(B2$B%P%$%HF~NO(B  CS$B$O(BLow ********/
unsigned int SPIRcv16(void){
    int i;
    unsigned int BitPos, data;

    data = 0;
    BitPos =0x8000;             // $B%S%C%H0LCV%j%;%C%H(B
    for(i=0; i<16; i++){            // 8$B%S%C%H7+$jJV$7(B
        SPISCK = 1;             // SCL High
        if(SPISI)               // $B%S%C%HF~NO(B
           data |= BitPos;
        BitPos = BitPos >> 1;           // $B%S%C%H%7%U%H(B
        SPISCK = 0;
    }
    return(data);
}

/**********************************
*  $B%k!<%WCY1d4X?t!!(Busec$BC10L(B
**********************************/
void delay_us(unsigned short usec){
    unsigned short i, Max;

    Max = usec * Fosc/14;
    for(i=0; i<Max; i++)
    {   }
}
/**********************************
*  $B%k!<%WCY1d4X?t!!(Bmsec$BC10L(B
**********************************/
void delay_ms(unsigned short msec){
    unsigned short i;

    for(i=0; i<msec; i++)
            delay_us(1000);
}
